# Write your own

{% hint style="success" %}
This is the official documentation of the `@forestadmin/agent` Node.js agent.
{% endhint %}

Each Plugin is nothing more than an `async function` that can perform customizations at either Agent level, Collection level, or both.

```javascript
export async function removeTimestamps(dataSource, collection, options) {
  // ... call customization methods here
}
```

3 parameters are provided:

| Name                                                                                                                                                               | Description                                                                                                                                                                                               |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <p>dataSource<br>(<a href="https://forestadmin.github.io/agent-nodejs/classes/_forestadmin_datasource-customizer.DataSourceCustomizer.html">API Reference</a>)</p> | An object that allows customizing the whole agent. It has the same interface than the `Agent` you manipulate outside of Plugins                                                                           |
| <p>collection<br>(<a href="https://forestadmin.github.io/agent-nodejs/classes/_forestadmin_datasource-customizer.CollectionCustomizer.html">API Reference</a>)</p> | An object that allows customizing the collection that the Plugin was called from (`null` if the Plugin was called on the Agent). It is the same object than is passed when you call `customizeCollection` |
| options                                                                                                                                                            | Options that are provided to the Plugin. There is no set structure for this parameter, as each Plugin will provide specific mandatory or optional options.                                                |

### Making your Plugin act differently depending on the Collection

When making a Plugin, you may want it to generalize to many different Collections.

This can be achieved by adopting different behavior depending on the `schema` of the Collection being targeted.

Relevant documentation:

* [DataSourceSchema](https://forestadmin.github.io/agent-nodejs/types/_forestadmin_datasource-toolkit.DataSourceSchema.html) (for Plugins working on Charts)
* [CollectionSchema](https://forestadmin.github.io/agent-nodejs/types/_forestadmin_datasource-toolkit.CollectionSchema.html) (for all other Plugins)

```javascript
export async function removeTimestamps(dataSource, collection, options) {
  for (const currentCollection of dataSource.collections) {
    if (currentCollection.schema.fields.createdAt) {
      currentCollection.removeField('createdAt');
    }

    if (currentCollection.schema.fields.updatedAt) {
      currentCollection.removeField('updatedAt');
    }
  }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-nodejs/agent-customization/plugins/custom.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
